"""\
Common code for all widget builders

@copyright: 2012 Carsten Grohmann <mail@carstengrohmann.de>
@license: MIT (see license.txt) - THIS PROGRAM COMES WITH NO WARRANTY
"""

# XXX siehe auch Klassen WidgetHandler ...

class BaseWidgetBuilder(object):
    """\
    Class to document attributes at the moment only.
    """
    
    extra_headers = []
    """\
    XXX
    """
    
    supported_by = ()
    """\
    This widget is only available at the listed wx versions. An empty list
    means the widgets is always available.
        
    Example for a widgets introduced with wx 2.8::
        supported_by = ((2, 8), (3, 0))

    @type: List of tuples with major and minor wx version number
    @see: L{wxglade.codegen.BaseCodeWriter.for_version}
    """

# end of class BaseWidgetBuilder
